// код ни разу не тестил, датчики не все и кодер я не оч, сорян за косяки 

void rotateRobot(int Angle);
void moveRobot(int Way); 
void bodyAction(long Position); // разложение
void handAction(int Sec); 
void headAction(int Sec); 


void loop() {
  
}


#include "SparkFunLSM6DS3.h" // библиотека для гироскопа, название - LSM6DS3, в .cpp и .h нужно закоментить Wire.Begin(0;
#include "Wire.h" 
#include <PRIZM.h> 

#define headServoSpeed            70
#define leftShoulderServoSpeed    60
#define rightShoulderServoSpeed   60
#define leftArmServoSpeed         60
#define rightArmServoSpeed        60

#define headServo           1
#define leftShoulderServo   2
#define rightShoulderServo  3
#define leftArmServo        4
#define rightArmServo       5 

#define TopPoint         28500 //старые данные нужно разложиться посмотреть что энкодэр показывает
#define TopPointKonz     1 // концевики не подключены поэтому по энкодеру поднимаемся
#define LowPointKonz     2 
 

LSM6DS3 myIMU(I2C_MODE, 0x6A); 
PRIZM prizm;
EXPANSION exc; // доп контроллеры для моторов функции те же что и на призме но нужно ID прописывать(правый - 1, по центру - 2)
 
void debug();

void setup() {
  Wire.begin(); 
  Serial.begin(9600); 
  if (myIMU.begin() != 0) { 
    Serial.println("Device error"); 
  } 
  else { 
    Serial.println("Device OK!"); 
  } 
  prizm.PrizmBegin();
  prizm.setServoSpeed(headServo, headServoSpeed);
  prizm.setServoSpeed(leftShoulderServo, leftShoulderServoSpeed);
  prizm.setServoSpeed(rightShoulderServo, rightShoulderServoSpeed);    
  prizm.setServoSpeed(leftArmServo, leftArmServoSpeed);
  prizm.setServoSpeed(rightArmServo, rightArmServoSpeed);
  pinMode(TopPointKonz, INPUT_PULLUP);
  pinMode(LowPointKonz, INPUT_PULLUP);
  debug(); 
}


void debug() {
  prizm.resetEncoders();// теоритический энкодер на омниплатформу его нет, по секундам
  exc.resetEncoders(2);
  prizm.setServoPosition(headServo, 90);
  prizm.setServoPosition(leftShoulderServo, 180);
  prizm.setServoPosition(rightShoulderServo, 0);
  prizm.setServoPosition(leftArmServo, 180);
  prizm.setServoPosition(rightArmServo, 0);
  while(digitalRead(LowPointKonz) == 0) { // калибровка подьемника
    exc.setMotorPower(2, -20, -20);
  }
  exc.setMotorPower(2, 0, 0);
}


void handAction(int Sec) {
  for(int i = 1; i <= Sec; i++) {
    prizm.setServoPosition(leftArmServo, random(0, 180)); delay(250);
    prizm.setServoPosition(rightShoulderServo, random(0, 180)); delay(250);
    prizm.setServoPosition(leftShoulderServo, random(0, 180)); delay(250);
    prizm.setServoPosition(rightArmServo, random(0, 180)); delay(250);
  }
  prizm.setServoPosition(leftShoulderServo, 180);
  prizm.setServoPosition(rightShoulderServo, 0);
  prizm.setServoPosition(leftArmServo, 180);
  prizm.setServoPosition(rightArmServo, 0);
}


void headAction(int Sec) {
  for (int i = 1; i <= Sec; i++) {
    prizm.setServoPosition(headServo, 0);
    delay(500);
    prizm.setServoPosition(headServo, 180);
    delay(500);
  }
  prizm.setServoPosition(headServo, 90);
}


float rawGyroZ, gyroZoffset, gyroZ, angleZ, fl; 
float angleGyroZ = 0, robotPosition = 0; 
int channel = 1;  

#define minError 10 
#define kofP 0.5 
#define kofD 0.7 

#define Speed 70

#define sgn(x) (x > 0 ? 1 : x < 0 ? -1 : 0)

const float encoderConst = ; // значения энкодера в сантиметры, я хз как для омнибота это считается, надо подобрать

void moveRobot(short Way) {
  rawGyroZ = myIMU.readRawGyroZ(); 
  gyroZ = ((float)rawGyroZ) / 65.5; 
  angleGyroZ += gyroZ + 0.75; 
  fl = angleGyroZ + angleGyroZ / 2 ; 
  robotPosition = fl / 27; // весь блок выше обработка данных с гироскопа, рабочий
  long error = 0, P = 0; 
  error = Way - encoderConst * prizm.readEncoderCount(1); 
  while(abs(error) > minError) { 
    P = robotPosition * kofP;
    prizm.setMotorPowers(sgn(Way) * Speed + P, sgn(Way) * Speed + P);
    exc.setMotorPowers(1, sgn(Way) * Speed - P, sgn(Way) * Speed - P);
  }
  exc.setMotorPowers(1, 0, 0);
  prizm.setMotorPowers(0, 0);
}

void rotateRobot(float Angle) { 
  rawGyroZ = myIMU.readRawGyroZ(); 
  gyroZ = ((float)rawGyroZ) / 65.5; 
  angleGyroZ += gyroZ + 0.75; 
  fl = angleGyroZ + angleGyroZ / 2 ; 
  robotPosition = fl / 27; 
  long error = 0, errorOld = 0, P = 0, D = 0; 
  float power = 0; 
  error = - Angle + robotPosition; 
  while(abs(error) > minError) { 
    P = error * kofP; 
    D = (error + errorOld) * kofD; 
    power = P + D; 
    exc.setMotorPowers(1, -power, -power); 
    prizm.setMotorPowers(power, power);
    errorOld = error; 
   } 
   exc.setMotorPowers(1, 0, 0); 
   prizm.setMotorPowers(0, 0);
} 

//рабочий блок
#define bodyActionDecelerationZone        3000
#define bodyActionDecelerationFactor      40
#define bodyActionAccelerationFactor      20
#define bodyActionMaxSpeed                100
#define bodyActionUsualSpeed              30
#define bodyActionMinError                50
#define leftMotor                         1
#define rightMotor                        2
#define sign(x) (x > 0 ? 1 : x < 0 ? -1 : 0)
void bodyAction(long Target) {
  long errorL = 0, encoderL = 0, errorR = 0, encoderR = 0;
  short powerL = 0, powerR = 0;
  prizm.setRedLED(HIGH);
  do {
    encoderL = exc.readEncoderCount(2, leftMotor);
    errorL = Target - encoderL;
    if(abs(errorL) > bodyActionDecelerationZone) powerL = bodyActionUsualSpeed * 2 * sign(errorL) + errorL / bodyActionAccelerationFactor;
    else powerL = bodyActionUsualSpeed * sign(errorL) + errorL / bodyActionDecelerationFactor;
    if (abs(powerL) > bodyActionMaxSpeed) powerL = bodyActionMaxSpeed * sign(powerL);
    
    encoderR = exc.readEncoderCount(2, rightMotor);
    errorR = -Target - encoderR;
    if(abs(errorR) > bodyActionDecelerationZone) powerR = bodyActionUsualSpeed * 2 * sign(errorR) + errorR / bodyActionAccelerationFactor;
    else powerR = bodyActionUsualSpeed * sign(errorR) + errorR / bodyActionDecelerationFactor;
    if (abs(powerR) > bodyActionMaxSpeed) powerR = bodyActionMaxSpeed * sign(powerR);
    
    exc.setMotorPowers(2, powerL, powerR);
  } while((abs(errorL) > bodyActionMinError and abs(errorR) > bodyActionMinError) or digitalRead(TopPointKonz) == 1);
  exc.setMotorPowers(2, 0, 0);
  prizm.setRedLED(LOW);
}
